//Rafa Wilk I1ISI

//Plik przedstawia zastosowanie generycznej klasy boost::value_initailized<T>,
//ktra zapewnia inicjacj obiektu domyln wartoci w momencie deklaracji.

#include <boost/utility/value_init.hpp>
#include <boost/utility.hpp>
#include <iostream>
#include <string>

using namespace std;
using namespace boost;

//Klasa pomagajca zobrazowa zastosowanie klasy boost:value_initialized<T>
class Data
{
protected:
	int value;
	char character;
public:
	int getValue() {return value;}
	char getChar() {return character;}
};

void print(int& i)
{
	//dowolny kod
};

int main()
{
	//--- Wstp --//

	//By zainicjowa zdeklarowanego int'a wartoci zero naley uy jednego z poniszych sposobw:
	int a = 0;
	int b = int();
	int c = initialized_value;
	//lub te zdeklarowa go koystajc z klasy value_initialized
	value_initialized<int> x;

	
	//--- Podstawowe zastosowania ---//

	//Prosty przykad pokazujcy podstawowe zastosowanie value_initialized:
	
	int x_std;
	value_initialized<int> x_v_init;
	
	//W zalenoci od systemu deklaracja int x_std; utworzy int'a zainicjowanego 
	//niezdeterminowan wartoci(Windows) lub zerem. Uywajc value_initialized pewnym jest, 
	//i int ma warto 0(jest to domylna warto inicjacji int'a).

	cout<< "\"int x;\":"<< endl << "\tx = " << x_std 
		<< endl << endl<< "\"value_initialized<int> x;\":"<< endl << "\tx = " << x_v_init << endl << endl;
	
	
	//Nastpny przykad dotyczy inicjacji wskanikw:
	
	value_initialized<Data*> ptr;

	if(ptr != NULL)
		delete ptr;
	
	//w momencie gdy ptr nie zosta zainicjowany zerem, jak mogo si wydarzy gdyby deklaracja
	//wygldaa nastpujco Data* ptr; zaistniaa by prba usunicia obiektu Data spod losowego
	//adresu.

	
	//Te same zasady dotycz innnych typw zmiennych, klas, wskanikw.
	//Warunkiem skorzystania z value_initialized jest by posiadanie domylnego konstruktora
	
	Data d_std;
	
	value_initialized<Data> d_v_init;
	
	//skadowe klasy Data zostay zainicjowane zerem.

	cout<<"\"Data d;\"" << endl << "\td.value: "<< d_std.getValue() << endl 
		<< "\td.character: '" << d_std.getChar() << "'" << endl << endl;

	cout<<"\"value_initialized<Data> d;\"" << endl << "\td.value: "<< get(d_v_init).getValue() 
		<< endl << "\td.character: '" << get(d_v_init).getChar() << "'" << endl << endl;

	
	//Kolejnym przykadem jest inicjacja domylna klas dziedziczcych po boost::noncopyable lub nieposiadajcych
	//lub posiadajcych prywatny konstruktor kopiujcy wtedy konstrukcja inicjujca wartoci domyln:
	
	Data d = Data();
	
	//nie ma prawa zadziaa natomiast value_initialized speni swoj rol, zastpujc powyszy kod.

	
	//Deklarujc typ bool inicjowany jest on domylnie wartoci false,co doskonale nadaje si do tworzenia 
	//zmiennych kontrolujcych wystpienie bdu, zapenienia, zajtoci. 
	value_initialized<bool> is_busy;
	if(is_busy)
		;//stop
	else
		;//pracuj
		
	
	//--- Dostp do referencji do wartoi deklarowanego typu --//
		
	//Istniej trzy moliwoci uzyskania referencji do zadeklarowanego typu:
	
	//1. operator T& ()
	print( x_v_init );
	
	//2. metoda T& data()
	print( x_v_init.data() );
	
	//3. funkcja T& get( value_initialized<T>& x ) ktra posiada te wersj T const& get ( value_initialized<T> const& x )
	print( get(x_v_init) );

	
	//--- value_initialized<T> a wartoci const ---//

	//Metoda data() klasy value_initialized zwraca zawsze referencj "nie const" bezwzgldu na to czy obiekt jest const,
	//moe to prowadzi do modyfikacji obiektu chronionego przed zmian. Dlatego te zaleca si stosowanie funckji get(),
	//zapewnia ona poprawne kontrol niezmiennoci.

	value_initialized<int> integer ;
	get(integer) = 1; //poprawny kod

	value_initialized<int const> const_integer ;
	//get(const_integer) = 1;  //bd nie mona zmodyfikowa obiektu const

	value_initialized<int> const integer_const ;
	//get(integer_const) = 1;  //bd nie mona zmodyfikowa obiektu const

	value_initialized<int const> const const_integer_const ;
	//get(const_integer_const) = 1;  //bd nie mona zmodyfikowa obiektu const
}

